type CssProperties = Record<string, CssNestedProperties | boolean | number | string>;
interface CssNestedProperties extends Record<string, unknown> {
    [k: string]: CssNestedProperties | boolean | number | string;
}
/**
 * Converts a CSS object to a CSS string.
 * @param {CssProperties | CssNestedProperties} cssObj - The CSS object to convert.
 * @returns {string} The CSS string.
 * @throws {TypeError} If the input is not a valid CSS object.
 */
declare function toCss(cssObj: CssNestedProperties | CssProperties): string;
export { CssNestedProperties, CssProperties, toCss };
//# sourceMappingURL=css-utilities.d.ts.map