"use strict";
/* eslint-disable @typescript-eslint/ban-types */
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.pickBy = exports.pick = exports.overSome = exports.overEvery = exports.over = exports.omitBy = exports.omit = exports.nthArg = exports.mixin = exports.methodOf = exports.method = exports.mergeWith = exports.merge = exports.matchesProperty = exports.matches = exports.mapValues = exports.mapKeys = exports.keysIn = exports.keys = exports.iteratee = exports.invoke = exports.invertBy = exports.invert = exports.identity = exports.has = exports.getType = exports.get = exports.functionsIn = exports.functions = exports.forOwnRight = exports.forOwn = exports.forInRight = exports.forIn = exports.flowRight = exports.flow = exports.flattenObject = exports.findLastKey = exports.findKey = exports.defaultsDeep = exports.defaults = exports.deepEqual = exports.create = exports.constant = exports.conforms = exports.cond = exports.bindAll = exports.assignWith = exports.assignInWith = exports.assignIn = exports.assign = void 0;
exports.valuesIn = exports.values = exports.valueAt = exports.updateWith = exports.update = exports.unset = exports.unixTimestamp = exports.uniqueId = exports.transform = exports.toPath = exports.toPairsIn = exports.toPairs = exports.times = exports.thru = exports.tap = exports.stubTrue = exports.stubString = exports.stubObject = exports.stubFunction = exports.stubFalse = exports.stubArray = exports.shallowEqual = exports.setWith = exports.set = exports.runInContext = exports.result = exports.rangeRight = exports.range = exports.propertyOf = exports.property = void 0;
/**
 * Invokes the given function with the provided value and returns the value. Use it to perform intermediate operations in a method chain.
 */
function tap(value, interceptor) {
    interceptor(value);
    return value;
}
exports.tap = tap;
/**
 * Executes the given function with the provided value and returns the result. Use it to perform a sequence of operations in a method chain.
 */
function thru(value, interceptor) {
    return interceptor(value);
}
exports.thru = thru;
/**
 * Copies the enumerable properties of the source object(s) to the destination object.
 */
function assign(target) {
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    Object.assign.apply(Object, __spreadArray([target], __read(sources), false));
    return target;
}
exports.assign = assign;
/**
 * Copies the enumerable and inherited properties of the source object(s) to the destination object.
 */
function assignIn(target) {
    var e_1, _a;
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    try {
        for (var sources_1 = __values(sources), sources_1_1 = sources_1.next(); !sources_1_1.done; sources_1_1 = sources_1.next()) {
            var source = sources_1_1.value;
            for (var key in source) {
                target[key] = source[key];
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (sources_1_1 && !sources_1_1.done && (_a = sources_1.return)) _a.call(sources_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return target;
}
exports.assignIn = assignIn;
/**
 * This method is like `assignIn` except that it accepts a customizer which is invoked to produce the assigned values.
 */
function assignInWith(target) {
    var e_2, _a;
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    try {
        for (var sources_2 = __values(sources), sources_2_1 = sources_2.next(); !sources_2_1.done; sources_2_1 = sources_2.next()) {
            var source = sources_2_1.value;
            for (var key in source) {
                target[key] = source[key];
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (sources_2_1 && !sources_2_1.done && (_a = sources_2.return)) _a.call(sources_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return target;
}
exports.assignInWith = assignInWith;
/**
 * This method is like `assign` except that it accepts a customizer which is invoked to produce the assigned values.
 */
function assignWith(target) {
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    Object.assign.apply(Object, __spreadArray([target], __read(sources), false));
    return target;
}
exports.assignWith = assignWith;
/**
 * Creates an array of values corresponding to paths of the object.
 */
function valueAt(object, paths, separator) {
    if (separator === void 0) { separator = "."; }
    return paths.map(function (path) {
        var e_3, _a;
        var keys = path.split(separator);
        var value = object;
        try {
            for (var keys_1 = __values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                var key = keys_1_1.value;
                if (value && typeof value === "object" && key in value) {
                    value = value[key];
                }
                else {
                    value = undefined;
                    break;
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return value;
    });
}
exports.valueAt = valueAt;
/**
 * Creates a new object with the specified prototype object and properties.
 */
function create(prototype, properties) {
    if (properties === void 0) { properties = {}; }
    return Object.create(prototype, properties);
}
exports.create = create;
/**
 * Assigns default properties of the source objects to the destination object.
 */
function defaults(object) {
    var e_4, _a;
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    try {
        for (var sources_3 = __values(sources), sources_3_1 = sources_3.next(); !sources_3_1.done; sources_3_1 = sources_3.next()) {
            var source = sources_3_1.value;
            for (var key in source) {
                if (!(key in object)) {
                    object[key] = source[key];
                }
            }
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (sources_3_1 && !sources_3_1.done && (_a = sources_3.return)) _a.call(sources_3);
        }
        finally { if (e_4) throw e_4.error; }
    }
    return object;
}
exports.defaults = defaults;
/**
 * This method is like `defaults` except that it recursively assigns default properties.
 */
function defaultsDeep(object) {
    var e_5, _a;
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    try {
        for (var sources_4 = __values(sources), sources_4_1 = sources_4.next(); !sources_4_1.done; sources_4_1 = sources_4.next()) {
            var source = sources_4_1.value;
            for (var key in source) {
                if (!(key in object)) {
                    object[key] = source[key];
                }
                else if (typeof object[key] === "object" &&
                    typeof source[key] === "object") {
                    defaultsDeep(object[key], source[key]);
                }
            }
        }
    }
    catch (e_5_1) { e_5 = { error: e_5_1 }; }
    finally {
        try {
            if (sources_4_1 && !sources_4_1.done && (_a = sources_4.return)) _a.call(sources_4);
        }
        finally { if (e_5) throw e_5.error; }
    }
    return object;
}
exports.defaultsDeep = defaultsDeep;
/**
 * This method returns the key of the first element predicate returns truthy for.
 */
function findKey(object, predicate) {
    for (var key in object) {
        if (predicate(object[key], key)) {
            return key;
        }
    }
}
exports.findKey = findKey;
/**
 * This method returns the key of the last element predicate returns truthy for.
 */
function findLastKey(object, predicate) {
    var keys = Object.keys(object);
    for (var i = keys.length - 1; i >= 0; i--) {
        var key = keys[i];
        if (predicate(object[key], key)) {
            return key;
        }
    }
}
exports.findLastKey = findLastKey;
/**
 * Iterates over own and inherited enumerable string keyed properties of an object, invoking `iteratee` for each property.
 */
function forIn(object, iteratee) {
    for (var key in object) {
        iteratee(object[key], key);
    }
    return object;
}
exports.forIn = forIn;
/**
 * This method is like `forIn` except that it iterates over properties in reverse order.
 */
function forInRight(object, iteratee) {
    var e_6, _a;
    var keys = Object.keys(object).reverse();
    try {
        for (var keys_2 = __values(keys), keys_2_1 = keys_2.next(); !keys_2_1.done; keys_2_1 = keys_2.next()) {
            var key = keys_2_1.value;
            iteratee(object[key], key);
        }
    }
    catch (e_6_1) { e_6 = { error: e_6_1 }; }
    finally {
        try {
            if (keys_2_1 && !keys_2_1.done && (_a = keys_2.return)) _a.call(keys_2);
        }
        finally { if (e_6) throw e_6.error; }
    }
    return object;
}
exports.forInRight = forInRight;
/**
 * Iterates over own enumerable string keyed properties of an object, invoking `iteratee` for each property.
 */
function forOwn(object, iteratee) {
    for (var key in object) {
        if (Object.prototype.hasOwnProperty.call(object, key)) {
            iteratee(object[key], key);
        }
    }
    return object;
}
exports.forOwn = forOwn;
/**
 * This method is like `forOwn` except that it iterates over properties in reverse order.
 */
function forOwnRight(object, iteratee) {
    var e_7, _a;
    var keys = Object.keys(object).reverse();
    try {
        for (var keys_3 = __values(keys), keys_3_1 = keys_3.next(); !keys_3_1.done; keys_3_1 = keys_3.next()) {
            var key = keys_3_1.value;
            if (Object.prototype.hasOwnProperty.call(object, key)) {
                iteratee(object[key], key);
            }
        }
    }
    catch (e_7_1) { e_7 = { error: e_7_1 }; }
    finally {
        try {
            if (keys_3_1 && !keys_3_1.done && (_a = keys_3.return)) _a.call(keys_3);
        }
        finally { if (e_7) throw e_7.error; }
    }
    return object;
}
exports.forOwnRight = forOwnRight;
/**
 * Creates an array of function property names from own enumerable properties of `object`.
 */
function functions(object) {
    var result = [];
    for (var key in object) {
        if (typeof object[key] === "function") {
            result.push(key);
        }
    }
    return result;
}
exports.functions = functions;
/**
 * Creates an array of function property names from own and inherited enumerable properties of `object`.
 */
function functionsIn(object) {
    var result = [];
    for (var key in object) {
        result.push(key);
    }
    return result;
}
exports.functionsIn = functionsIn;
/**
 * Gets the value at `path` of `object`.
 */
function get(object, path, defaultValue, separator) {
    var e_8, _a;
    if (separator === void 0) { separator = "."; }
    var pathArray = Array.isArray(path) ? path : path.split(separator);
    var result = object;
    try {
        for (var pathArray_1 = __values(pathArray), pathArray_1_1 = pathArray_1.next(); !pathArray_1_1.done; pathArray_1_1 = pathArray_1.next()) {
            var key = pathArray_1_1.value;
            if (result == null) {
                return defaultValue;
            }
            result = result[key];
        }
    }
    catch (e_8_1) { e_8 = { error: e_8_1 }; }
    finally {
        try {
            if (pathArray_1_1 && !pathArray_1_1.done && (_a = pathArray_1.return)) _a.call(pathArray_1);
        }
        finally { if (e_8) throw e_8.error; }
    }
    return result !== undefined ? result : defaultValue;
}
exports.get = get;
/**
 * Checks if `path` is a direct property of `object`.
 */
function has(object, path, separator) {
    var e_9, _a;
    if (separator === void 0) { separator = "."; }
    var pathArray = Array.isArray(path) ? path : path.split(separator);
    var result = object;
    try {
        for (var pathArray_2 = __values(pathArray), pathArray_2_1 = pathArray_2.next(); !pathArray_2_1.done; pathArray_2_1 = pathArray_2.next()) {
            var key = pathArray_2_1.value;
            if (result == null || !(key in result)) {
                return false;
            }
            result = result[key];
        }
    }
    catch (e_9_1) { e_9 = { error: e_9_1 }; }
    finally {
        try {
            if (pathArray_2_1 && !pathArray_2_1.done && (_a = pathArray_2.return)) _a.call(pathArray_2);
        }
        finally { if (e_9) throw e_9.error; }
    }
    return true;
}
exports.has = has;
/**
 * Creates an object composed of the inverted keys and values of `object`.
 */
function invert(object) {
    var result = {};
    for (var key in object) {
        result[object[key]] = key;
    }
    return result;
}
exports.invert = invert;
/**
 * This method is like `invert` except that it group the inverted values by iteratee.
 */
function invertBy(object, iteratee) {
    var result = {};
    for (var key in object) {
        var value = object[key];
        var invertedKey = iteratee(value);
        if (invertedKey in result) {
            result[invertedKey].push(key);
        }
        else {
            result[invertedKey] = [key];
        }
    }
    return result;
}
exports.invertBy = invertBy;
/**
 * Invokes the method at `path` of `object`.
 */
function invoke(object, path) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        args[_i - 2] = arguments[_i];
    }
    var method = get(object, path);
    if (typeof method === "function") {
        return method.apply(object, args);
    }
}
exports.invoke = invoke;
/**
 * Creates an array of the own enumerable property names of `object`.
 */
function keys(object) {
    return Object.keys(object);
}
exports.keys = keys;
/**
 * Creates an array of the own and inherited enumerable property names of `object`.
 */
function keysIn(object) {
    var result = [];
    for (var key in object) {
        result.push(key);
    }
    return result;
}
exports.keysIn = keysIn;
/**
 * Creates an object with the same keys as `object` and values generated by running each own enumerable string keyed property of `object` through `iteratee`.
 */
function mapKeys(object, iteratee) {
    var result = {};
    for (var key in object) {
        var value = object[key];
        result[iteratee(value, key)] = value;
    }
    return result;
}
exports.mapKeys = mapKeys;
/**
 * Creates an object with the same keys as `object` and values generated by running each own enumerable string keyed property of `object` through `iteratee`.
 */
function mapValues(object, iteratee) {
    var result = {};
    for (var key in object) {
        result[key] = iteratee(object[key], key);
    }
    return result;
}
exports.mapValues = mapValues;
/**
 * Recursively merges own and inherited enumerable string keyed properties of source objects into the destination object.
 */
function merge(object) {
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    Object.assign.apply(Object, __spreadArray([object], __read(sources), false));
    return object;
}
exports.merge = merge;
/**
 * This method is like `merge` except that it accepts a customizer which is invoked to produce the merged values.
 */
function mergeWith(object) {
    var e_10, _a;
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    try {
        for (var sources_5 = __values(sources), sources_5_1 = sources_5.next(); !sources_5_1.done; sources_5_1 = sources_5.next()) {
            var source = sources_5_1.value;
            for (var key in source) {
                var targetValue = object[key];
                var sourceValue = source[key];
                if (targetValue !== sourceValue) {
                    object[key] = sourceValue;
                }
            }
        }
    }
    catch (e_10_1) { e_10 = { error: e_10_1 }; }
    finally {
        try {
            if (sources_5_1 && !sources_5_1.done && (_a = sources_5.return)) _a.call(sources_5);
        }
        finally { if (e_10) throw e_10.error; }
    }
    return object;
}
exports.mergeWith = mergeWith;
/**
 * Creates an object composed of the object properties omitted based on the given keys.
 */
function omit(object, keys) {
    var result = {};
    for (var key in object) {
        if (!keys.includes(key)) {
            result[key] = object[key];
        }
    }
    return result;
}
exports.omit = omit;
/**
 * Creates an object composed of the object properties omitted based on the given predicate.
 */
function omitBy(object, predicate) {
    var result = {};
    for (var key in object) {
        var value = object[key];
        if (!predicate(value, key)) {
            result[key] = value;
        }
    }
    return result;
}
exports.omitBy = omitBy;
/**
 * Creates an object composed of the picked object properties.
 */
function pick(object, keys) {
    var e_11, _a;
    var result = {};
    try {
        for (var keys_4 = __values(keys), keys_4_1 = keys_4.next(); !keys_4_1.done; keys_4_1 = keys_4.next()) {
            var key = keys_4_1.value;
            if (key in object) {
                result[key] = object[key];
            }
        }
    }
    catch (e_11_1) { e_11 = { error: e_11_1 }; }
    finally {
        try {
            if (keys_4_1 && !keys_4_1.done && (_a = keys_4.return)) _a.call(keys_4);
        }
        finally { if (e_11) throw e_11.error; }
    }
    return result;
}
exports.pick = pick;
/**
 * Creates an object composed of the object properties picked based on the given predicate.
 */
function pickBy(object, predicate) {
    var result = {};
    for (var key in object) {
        var value = object[key];
        if (predicate(value, key)) {
            result[key] = value;
        }
    }
    return result;
}
exports.pickBy = pickBy;
/**
 * Gets the value at `path` of `object`. If the resolved value is a function, it's invoked with the `this` binding of its parent object and its result is returned.
 */
function result(object, path, defaultValue) {
    var value = get(object, path, defaultValue);
    if (typeof value === "function") {
        return value.call(object);
    }
    return value;
}
exports.result = result;
/**
 * Sets the value at `path` of `object`. If a portion of `path` doesn't exist, it's created.
 */
function set(object, path, value, separator) {
    if (separator === void 0) { separator = "."; }
    var pathArray = Array.isArray(path) ? path : path.split(separator);
    var result = object;
    for (var i = 0; i < pathArray.length - 1; i++) {
        var key = pathArray[i];
        if (!(key in result)) {
            result[key] = {};
        }
        result = result[key];
    }
    result[pathArray[pathArray.length - 1]] = value;
    return object;
}
exports.set = set;
/**
 * This method is like `set` except that it accepts a customizer which is invoked to produce the object of path.
 */
function setWith(object, path, value, customizer, separator) {
    if (separator === void 0) { separator = "."; }
    var pathArray = Array.isArray(path) ? path : path.split(separator);
    var result = object;
    for (var i = 0; i < pathArray.length - 1; i++) {
        var key = pathArray[i];
        if (!(key in result)) {
            result[key] = customizer(undefined, pathArray.slice(i + 1).join(separator), object);
        }
        result = result[key];
    }
    result[pathArray[pathArray.length - 1]] = value;
    return object;
}
exports.setWith = setWith;
/**
 * Creates an array of own enumerable string keyed-value pairs for `object`.
 */
function toPairs(object) {
    return Object.entries(object);
}
exports.toPairs = toPairs;
/**
 * Creates an array of own and inherited enumerable string keyed-value pairs for `object`.
 */
function toPairsIn(object) {
    var result = [];
    for (var key in object) {
        result.push([key, object[key]]);
    }
    return result;
}
exports.toPairsIn = toPairsIn;
/**
 * Recursively merges own enumerable string keyed properties of source objects into the destination object.
 */
function transform(object, iteratee, accumulator) {
    var e_12, _a;
    var keys = Object.keys(object);
    try {
        for (var keys_5 = __values(keys), keys_5_1 = keys_5.next(); !keys_5_1.done; keys_5_1 = keys_5.next()) {
            var key = keys_5_1.value;
            if (iteratee(accumulator, object[key], key, object) ===
                false) {
                break;
            }
        }
    }
    catch (e_12_1) { e_12 = { error: e_12_1 }; }
    finally {
        try {
            if (keys_5_1 && !keys_5_1.done && (_a = keys_5.return)) _a.call(keys_5);
        }
        finally { if (e_12) throw e_12.error; }
    }
    return accumulator || object;
}
exports.transform = transform;
/**
 * Removes the property at `path` of `object`.
 */
function unset(object, path, separator) {
    if (separator === void 0) { separator = "."; }
    var pathArray = Array.isArray(path) ? path : path.split(separator);
    var result = false;
    if (pathArray.length === 1) {
        result = delete object[pathArray[0]];
    }
    else {
        var current = object;
        for (var i = 0; i < pathArray.length - 1; i++) {
            var key = pathArray[i];
            if (!(key in current)) {
                result = false;
                break;
            }
            current = current[key];
        }
        if (!result) {
            result = delete current[pathArray[pathArray.length - 1]];
        }
    }
    return result;
}
exports.unset = unset;
/**
 * This method is like `set` except that it accepts a updater to produce the value to set.
 */
function update(object, path, updater) {
    var newValue = updater(get(object, path));
    set(object, path, newValue);
    return object;
}
exports.update = update;
/**
 * This method is like `update` except that it accepts a customizer which is invoked to produce the value to set.
 */
function updateWith(object, path, updater, customizer) {
    var pathArray = Array.isArray(path) ? path : path.split(".");
    var newValue = updater(get(object, path), pathArray[pathArray.length - 1], object);
    setWith(object, path, newValue, customizer);
    return object;
}
exports.updateWith = updateWith;
/**
 * Creates an array of the own enumerable string keyed property values of `object`.
 */
function values(object) {
    return Object.values(object);
}
exports.values = values;
/**
 * Creates an array of the own and inherited enumerable string keyed property values of `object`.
 */
function valuesIn(object) {
    var result = [];
    for (var key in object) {
        result.push(object[key]);
    }
    return result;
}
exports.valuesIn = valuesIn;
/**
 * Flattens an object. This function can also handle objects that have child objects.
 * Child objects are retrieved using the provided `getChildren` function.
 * The resulting array contains all objects and their children in a flat structure.
 * @param rootObject - The root object to be flattened.
 * @param getChildren - A function that, given an object, returns its child objects or undefined.
 * @returns A flat array containing the root object and its child objects.
 */
function flattenObject(rootObject, getChildren) {
    var e_13, _a;
    var result = [];
    if (!rootObject) {
        return result;
    }
    result.push(rootObject);
    var children = getChildren === null || getChildren === void 0 ? void 0 : getChildren(rootObject);
    if (!children) {
        return result;
    }
    try {
        for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
            var child = children_1_1.value;
            if (child) {
                result.push.apply(result, __spreadArray([], __read(flattenObject(child, getChildren)), false));
            }
        }
    }
    catch (e_13_1) { e_13 = { error: e_13_1 }; }
    finally {
        try {
            if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
        }
        finally { if (e_13) throw e_13.error; }
    }
    return result;
}
exports.flattenObject = flattenObject;
// Binds methods of an object to the object itself, overwriting the original methods
function bindAll(object) {
    var methodNames = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        methodNames[_i - 1] = arguments[_i];
    }
    methodNames.forEach(function (methodName) {
        object[methodName] = object[methodName].bind(object);
    });
}
exports.bindAll = bindAll;
// Creates a function that iterates over a list of predicate-function pairs and returns the value of the first predicate that evaluates to true
function cond(pairs) {
    return function () {
        var e_14, _a;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        try {
            for (var pairs_1 = __values(pairs), pairs_1_1 = pairs_1.next(); !pairs_1_1.done; pairs_1_1 = pairs_1.next()) {
                var _b = __read(pairs_1_1.value, 2), predicate = _b[0], transform_1 = _b[1];
                if (predicate.apply(void 0, __spreadArray([], __read(args), false))) {
                    return transform_1.apply(void 0, __spreadArray([], __read(args), false));
                }
            }
        }
        catch (e_14_1) { e_14 = { error: e_14_1 }; }
        finally {
            try {
                if (pairs_1_1 && !pairs_1_1.done && (_a = pairs_1.return)) _a.call(pairs_1);
            }
            finally { if (e_14) throw e_14.error; }
        }
    };
}
exports.cond = cond;
// Creates a function that checks if all properties of a source object conform to corresponding predicate functions
function conforms(source) {
    return function (object) {
        for (var key in source) {
            if (!source[key](object[key])) {
                return false;
            }
        }
        return true;
    };
}
exports.conforms = conforms;
// Returns a function that always returns a constant value
function constant(value) {
    return function () {
        return value;
    };
}
exports.constant = constant;
// Creates a composed function by chaining multiple functions together
function flow() {
    var funcs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        funcs[_i] = arguments[_i];
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return funcs.reduce(function (result, func) { return func(result); }, args);
    };
}
exports.flow = flow;
// Creates a composed function by chaining multiple functions together in reverse order
function flowRight() {
    var funcs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        funcs[_i] = arguments[_i];
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return funcs.reduceRight(function (result, func) { return func(result); }, args);
    };
}
exports.flowRight = flowRight;
// Returns the first argument it receives
function identity(value) {
    return value;
}
exports.identity = identity;
// Creates a function that returns the property value at a given path of an object
function iteratee(path, separator) {
    if (separator === void 0) { separator = "."; }
    var pathArray = Array.isArray(path) ? path : path.split(separator);
    return function (object) {
        var e_15, _a;
        var result = object;
        try {
            for (var pathArray_3 = __values(pathArray), pathArray_3_1 = pathArray_3.next(); !pathArray_3_1.done; pathArray_3_1 = pathArray_3.next()) {
                var key = pathArray_3_1.value;
                if (typeof result === "object" &&
                    result !== null &&
                    key in result) {
                    result = result[key];
                }
                else {
                    return undefined;
                }
            }
        }
        catch (e_15_1) { e_15 = { error: e_15_1 }; }
        finally {
            try {
                if (pathArray_3_1 && !pathArray_3_1.done && (_a = pathArray_3.return)) _a.call(pathArray_3);
            }
            finally { if (e_15) throw e_15.error; }
        }
        return result;
    };
}
exports.iteratee = iteratee;
// Creates a function that checks if an object has the specified properties and values
function matches(source) {
    return function (object) {
        for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key) &&
                source[key] !== object[key]) {
                return false;
            }
        }
        return true;
    };
}
exports.matches = matches;
// Creates a function that checks if an object has a property with the specified key and value
function matchesProperty(path, value) {
    var iterateeFunc = iteratee(path);
    return function (object) {
        return iterateeFunc(object) === value;
    };
}
exports.matchesProperty = matchesProperty;
// Creates a function that invokes the method at the specified path of an object
function method(path) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    var iterateeFunc = iteratee(path);
    return function (object) {
        var method = iterateeFunc(object);
        return method.apply(object, args);
    };
}
exports.method = method;
// Creates a function that invokes the method at the specified path of a provided object
function methodOf(object) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return function (path) {
        var iterateeFunc = iteratee(path);
        var method = iterateeFunc(object);
        return method.apply(object, args);
    };
}
exports.methodOf = methodOf;
// Extends an object with properties from other objects
function mixin(object) {
    var sources = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        sources[_i - 1] = arguments[_i];
    }
    sources.forEach(function (source) {
        for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
                object[key] = source[key];
            }
        }
    });
    return object;
}
exports.mixin = mixin;
// Creates a function that returns the nth argument it receives
function nthArg(n) {
    if (n === void 0) { n = 0; }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return args[n];
    };
}
exports.nthArg = nthArg;
// Creates a function that invokes multiple functions with the same arguments and returns an array of the results
function over() {
    var iteratees = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        iteratees[_i] = arguments[_i];
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return iteratees.map(function (iteratee) { return iteratee.apply(void 0, __spreadArray([], __read(args), false)); });
    };
}
exports.over = over;
// Creates a function that checks if all of the provided predicates return true
function overEvery() {
    var predicates = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        predicates[_i] = arguments[_i];
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return predicates.every(function (predicate) { return predicate.apply(void 0, __spreadArray([], __read(args), false)); });
    };
}
exports.overEvery = overEvery;
// Creates a function that checks if any of the provided predicates return true
function overSome() {
    var predicates = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        predicates[_i] = arguments[_i];
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return predicates.some(function (predicate) { return predicate.apply(void 0, __spreadArray([], __read(args), false)); });
    };
}
exports.overSome = overSome;
// Creates a function that returns the value of a property at a given path of an object
function property(path) {
    var iterateeFunc = iteratee(path);
    return function (object) {
        return iterateeFunc(object);
    };
}
exports.property = property;
// Creates a function that returns the value of a property at a given path of a provided object
function propertyOf(object) {
    return function (path) {
        var iterateeFunc = iteratee(path);
        return iterateeFunc(object);
    };
}
exports.propertyOf = propertyOf;
// Creates an array of numbers in the specified range
function range(start, end, step) {
    if (step === void 0) { step = 1; }
    if (end === undefined) {
        end = start;
        start = 0;
    }
    var result = [];
    for (var i = start; i < end; i += step) {
        result.push(i);
    }
    return result;
}
exports.range = range;
// Creates an array of numbers in the specified range in reverse order
function rangeRight(start, end, step) {
    if (step === void 0) { step = 1; }
    if (end === undefined) {
        end = start;
        start = 0;
    }
    var result = [];
    for (var i = end - step; i >= start; i -= step) {
        result.push(i);
    }
    return result;
}
exports.rangeRight = rangeRight;
// Runs a function inside a specified context
function runInContext(context) {
    return function (func) {
        return func.call(context);
    };
}
exports.runInContext = runInContext;
// Returns a function that does nothing and returns undefined
function stubFunction() {
    return function () { return undefined; };
}
exports.stubFunction = stubFunction;
// Returns a new empty array
function stubArray() {
    return [];
}
exports.stubArray = stubArray;
// Returns false
function stubFalse() {
    return false;
}
exports.stubFalse = stubFalse;
// Returns an empty object
function stubObject() {
    return {};
}
exports.stubObject = stubObject;
// Returns an empty string
function stubString(value) {
    return value || "";
}
exports.stubString = stubString;
// Returns true
function stubTrue() {
    return true;
}
exports.stubTrue = stubTrue;
// Invokes a provided function a specified number of times and returns an array of the results
function times(n, iteratee) {
    var result = [];
    for (var i = 0; i < n; i++) {
        result.push(iteratee(i));
    }
    return result;
}
exports.times = times;
// Converts a string to an array of its property paths
function toPath(value, separator) {
    if (separator === void 0) { separator = "."; }
    return Array.isArray(value) ? value : value.split(separator);
}
exports.toPath = toPath;
// Generates a unique ID
function uniqueId() {
    var dateString = Date.now().toString(36);
    var randomness = Math.random().toString(36).substring(2);
    return dateString + randomness;
}
exports.uniqueId = uniqueId;
function unixTimestamp(date) {
    if (date === void 0) { date = Date.now(); }
    return Math.floor(date / 1000);
}
exports.unixTimestamp = unixTimestamp;
function getType(val) {
    return Object.prototype.toString.call(val).slice(8, -1);
}
exports.getType = getType;
function deepEqual(a, b) {
    var e_16, _a;
    if (a === b)
        return true;
    if (typeof a === "object" &&
        a !== null &&
        typeof b === "object" &&
        b !== null) {
        var aIsArray = Array.isArray(a);
        var bIsArray = Array.isArray(b);
        if (aIsArray !== bIsArray)
            return false;
        if (aIsArray && bIsArray) {
            if (a.length !== b.length)
                return false;
            for (var i = 0; i < a.length; i++) {
                if (!deepEqual(a[i], b[i]))
                    return false;
            }
            return true;
        }
        var aKeys = Object.keys(a);
        var bKeys = Object.keys(b);
        if (aKeys.length !== bKeys.length)
            return false;
        try {
            for (var aKeys_1 = __values(aKeys), aKeys_1_1 = aKeys_1.next(); !aKeys_1_1.done; aKeys_1_1 = aKeys_1.next()) {
                var key = aKeys_1_1.value;
                if (!bKeys.includes(key) ||
                    !deepEqual(a[key], b[key]))
                    return false;
            }
        }
        catch (e_16_1) { e_16 = { error: e_16_1 }; }
        finally {
            try {
                if (aKeys_1_1 && !aKeys_1_1.done && (_a = aKeys_1.return)) _a.call(aKeys_1);
            }
            finally { if (e_16) throw e_16.error; }
        }
        return true;
    }
    return false;
}
exports.deepEqual = deepEqual;
function shallowEqual(a, b) {
    var e_17, _a;
    if (a === b)
        return true;
    if (typeof a === "object" &&
        a !== null &&
        typeof b === "object" &&
        b !== null) {
        var aKeys = Object.keys(a);
        var bKeys = Object.keys(b);
        if (aKeys.length !== bKeys.length)
            return false;
        try {
            for (var aKeys_2 = __values(aKeys), aKeys_2_1 = aKeys_2.next(); !aKeys_2_1.done; aKeys_2_1 = aKeys_2.next()) {
                var key = aKeys_2_1.value;
                if (!bKeys.includes(key) ||
                    a[key] !==
                        b[key])
                    return false;
            }
        }
        catch (e_17_1) { e_17 = { error: e_17_1 }; }
        finally {
            try {
                if (aKeys_2_1 && !aKeys_2_1.done && (_a = aKeys_2.return)) _a.call(aKeys_2);
            }
            finally { if (e_17) throw e_17.error; }
        }
        return true;
    }
    return false;
}
exports.shallowEqual = shallowEqual;
//# sourceMappingURL=object-utilities.js.map