var Either = /** @class */ (function () {
    function Either() {
    }
    Either.Left = function (value) {
        return { tag: "Left", value: value };
    };
    Either.Right = function (value) {
        return { tag: "Right", value: value };
    };
    Either.equals = function (e1, e2, equalityFn) {
        if (equalityFn === void 0) { equalityFn = function (a, b) { return a === b; }; }
        return ((this.isRight(e1) &&
            this.isRight(e2) &&
            equalityFn(e1.value, e2.value)) ||
            (this.isLeft(e1) && this.isLeft(e2) && e1.value === e2.value));
    };
    Either.flatMap = function (f, e) {
        return this.isRight(e) ? f(e.value) : e;
    };
    Either.fold = function (onLeft, onRight, e) {
        return this.isRight(e) ? onRight(e.value) : onLeft(e.value);
    };
    Either.getOrElse = function (defaultValue, e) {
        return this.isRight(e) ? e.value : defaultValue;
    };
    Either.isLeft = function (e) {
        return e.tag === "Left";
    };
    Either.isRight = function (e) {
        return e.tag === "Right";
    };
    Either.map = function (f, e) {
        return this.isRight(e) ? this.Right(f(e.value)) : e;
    };
    Either.orElse = function (f, e) {
        return this.isLeft(e) ? f(e.value) : e;
    };
    return Either;
}());
export { Either };
//# sourceMappingURL=either.js.map