export interface JsonPropertyInfo {
    name: string;
    type: null | string;
    value: unknown;
}
declare function getJsonPropertyInfos(obj: unknown): JsonPropertyInfo[];
declare function getJsonProperties(obj: unknown, hasIndexer?: boolean): string[];
declare function getJsonPropertiesWithType(obj: unknown, hasIndexer?: boolean): string[];
declare function isValidJson(str: string): boolean;
declare function tryValidateJson(str: string): {
    isValid: boolean;
    value: unknown;
};
declare function getObjectKeyValuePairs(obj: Record<string, unknown>, separator?: string): [string, unknown][];
declare function flattenJson(obj: Record<string, unknown>, separator: string, prefix?: string): Record<string, unknown>;
declare function unflattenJson(obj: Record<string, unknown>, separator: string): Record<string, unknown>;
export { flattenJson, getJsonProperties, getJsonPropertiesWithType, getJsonPropertyInfos, getObjectKeyValuePairs, isValidJson, tryValidateJson, unflattenJson, };
//# sourceMappingURL=json-utilities.d.ts.map